'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var generatePrefs = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(profileDir, port) {
        var prefsFileName, prefs;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        prefsFileName = _path2.default.join(profileDir, 'user.js');
                        prefs = ['user_pref("browser.link.open_newwindow.override.external", 2);', 'user_pref("app.update.enabled", false);', 'user_pref("app.update.auto", false);', 'user_pref("app.update.mode", 0);', 'user_pref("app.update.service.enabled", false);', 'user_pref("browser.shell.checkDefaultBrowser", false);', 'user_pref("browser.usedOnWindows10", true);', 'user_pref("browser.rights.3.shown", true);', 'user_pref("browser.startup.homepage_override.mstone","ignore");', 'user_pref("browser.tabs.warnOnCloseOtherTabs", false);', 'user_pref("browser.tabs.warnOnClose", false);', 'user_pref("browser.sessionstore.resume_from_crash", false);', 'user_pref("toolkit.telemetry.reportingpolicy.firstRun", false);', 'user_pref("toolkit.telemetry.enabled", false);', 'user_pref("toolkit.telemetry.rejected", true);', 'user_pref("datareporting.healthreport.uploadEnabled", false);', 'user_pref("datareporting.healthreport.service.enabled", false);', 'user_pref("datareporting.healthreport.service.firstRun", false);', 'user_pref("datareporting.policy.dataSubmissionEnabled", false);', 'user_pref("datareporting.policy.dataSubmissionPolicyBypassNotification", true);', 'user_pref("app.shield.optoutstudies.enabled", false);', 'user_pref("extensions.shield-recipe-client.enabled", false);', 'user_pref("extensions.shield-recipe-client.first_run", false);', 'user_pref("extensions.shield-recipe-client.startupExperimentPrefs.browser.newtabpage.activity-stream.enabled", false);', 'user_pref("devtools.toolbox.host", "window");', 'user_pref("devtools.toolbox.previousHost", "bottom");', 'user_pref("signon.rememberSignons", false);'];


                        if (port) {
                            prefs = prefs.concat(['user_pref("marionette.port", ' + port + ');', 'user_pref("marionette.enabled", true);']);
                        }

                        _context.next = 5;
                        return (0, _promisifiedFunctions.writeFile)(prefsFileName, prefs.join('\n'));

                    case 5:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function generatePrefs(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _endpointUtils = require('endpoint-utils');

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _promisifiedFunctions = require('../../../../utils/promisified-functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createTempProfileDir() {
    _tmp2.default.setGracefulCleanup();

    return _tmp2.default.dirSync({ unsafeCleanup: true });
}

exports.default = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(configString) {
        var config, marionettePort, tempProfileDir;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        config = (0, _config2.default)(configString);

                        if (!config.headless) {
                            _context2.next = 10;
                            break;
                        }

                        _context2.t1 = config.marionettePort;

                        if (_context2.t1) {
                            _context2.next = 7;
                            break;
                        }

                        _context2.next = 6;
                        return (0, _endpointUtils.getFreePort)();

                    case 6:
                        _context2.t1 = _context2.sent;

                    case 7:
                        _context2.t0 = _context2.t1;
                        _context2.next = 11;
                        break;

                    case 10:
                        _context2.t0 = null;

                    case 11:
                        marionettePort = _context2.t0;
                        tempProfileDir = !config.userProfile ? createTempProfileDir() : null;

                        if (config.userProfile) {
                            _context2.next = 16;
                            break;
                        }

                        _context2.next = 16;
                        return generatePrefs(tempProfileDir.name, marionettePort);

                    case 16:
                        return _context2.abrupt('return', { config: config, tempProfileDir: tempProfileDir, marionettePort: marionettePort });

                    case 17:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function (_x3) {
        return _ref2.apply(this, arguments);
    };
}();

module.exports = exports['default'];